## murasaki 0.5.4

=== Makefile ===
#
# Makefile for murasaki
#
#			Shuu Yamaguchi <shuu@dotaster.com>

all:
	cd lib;make
	cd usb;make
	cd pci;make
	cd net;make
	cd ieee1394;make
	cd hotplug;make

clean:
	cd lib;make clean
	cd usb;make clean
	cd pci;make clean
	cd net;make clean
	cd ieee1394;make clean
	cd hotplug;make clean
	cd scripts;make clean
	cd config;make clean

clobber:
	cd lib;make clobber
	cd usb;make clobber
	cd pci;make clobber
	cd net;make clobber
	cd ieee1394;make clobber
	cd hotplug;make clobber

install:
	cd config;make install
	cd usb;make install
	cd pci;make install
	cd net;make install
	cd ieee1394;make install
	cd hotplug;make install
	cd scripts;make install

=== ieee1394/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotaster.com

include ../make.defs

CMD=$(LM_IEEE1394)
SRCS_IEEE1394=main.c id.c match.c print.c loader.c op.c action.c
OBJS_IEEE1394=$(SRCS_IEEE1394:.c=.o)
OBJS_EX=../lib/depend.o ../lib/beep.o ../lib/list.o
OBJS=$(OBJS_IEEE1394) $(OBJS_EX)
MAPNAME=ieee1394map
IEEE1394MAP=$(LM).$(MAPNAME)
DEFAULT_IEEE1394MAP=modules.$(MAPNAME)
MAP=$(IEEE1394MAP)
IEEE1394_DEF=-DMURASAKI_IEEE1394 \
	-DMU_IEEE1394MAP=\"$(IEEE1394MAP)\" \
	-DMU_DEFAULT_IEEE1394MAP=\"$(DEFAULT_IEEE1394MAP)\" 
CFLAGS += $(IEEE1394_DEF)

include ../make.rules

=== lib/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotaster.com

include ../make.defs

SRCS=depend.c beep.c list.c
OBJS=$(SRCS:.c=.o)
LINK_FILE=loader.c main.c action.c
DIR=usb pci net ieee1394

all: $(OBJS) link

clean:
	rm -f *.o
	@for f in $(LINK_FILE); \
	do \
		for d in $(DIR); \
		do \
			rm -f ../$$d/$$f; \
		done \
	done

link:
	@for f in $(LINK_FILE); \
	do \
		for d in $(DIR); \
		do \
			ln -sf ../lib/$$f ../$$d;\
		done \
	done

clobber: clean

install:
	@echo 'nothing to do'

=== net/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotaster.com

include ../make.defs

CMD=$(LM_NET)
SRCS_NET=main.c interface.c action.c execute.c op.c
OBJS_NET=$(SRCS_NET:.c=.o)
OBJS_EX=
OBJS=$(OBJS_NET) $(OBJS_EX)
NET_UP=ifup
NET_DOWN=ifdown
NET_DEF=-DMURASAKI_NET \
	-DMU_NET_UP=\"$(NET_UP)\" \
	-DMU_NET_DOWN=\"$(NET_DOWN)\"
CFLAGS += $(NET_DEF)

include ../make.rules

=== pci/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotaster.com

include ../make.defs

CMD=$(LM_PCI)
SRCS_PCI=main.c class.c id.c bus.c print.c match.c loader.c op.c action.c
OBJS_PCI=$(SRCS_PCI:.c=.o)
OBJS_EX=../lib/depend.o ../lib/beep.o ../lib/list.o
OBJS=$(OBJS_PCI) $(OBJS_EX)
MAPNAME=pcimap
PCIMAP=$(LM).$(MAPNAME)
DEFAULT_PCIMAP=modules.$(MAPNAME)
MAP=$(PCIMAP)
PCI_DEF=-DMURASAKI_PCI \
	-DMU_PCIMAP=\"$(PCIMAP)\" \
	-DMU_DEFAULT_PCIMAP=\"$(DEFAULT_PCIMAP)\"

CFLAGS += $(PCI_DEF)

include ../make.rules

=== usb/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotaster.com

include ../make.defs

CMD=$(LM_USB)
SRCS_USB=main.c product.c type.c match.c print.c loader.c op.c action.c
OBJS_USB=$(SRCS_USB:.c=.o)
OBJS_EX=../lib/depend.o ../lib/beep.o ../lib/list.o
OBJS=$(OBJS_USB) $(OBJS_EX)
MAPNAME=usbmap
USBMAP=$(LM).$(MAPNAME)
DEFAULT_USBMAP=modules.$(MAPNAME)
MAP=$(USBMAP)
USB_DEF=-DMURASAKI_USB \
	-DMU_USBMAP=\"$(USBMAP)\" \
	-DMU_DEFAULT_USBMAP=\"$(DEFAULT_USBMAP)\" 
CFLAGS += $(USB_DEF)

include ../make.rules

## murasaki 0.6.11-1

=== Makefile ===
#
# Makefile for murasaki
#
#			Shuu Yamaguchi <shuu@dotaster.com>

all:
	cd lib;make
	cd hotplug;make
	cd usb;make
	cd pci;make
	cd net;make
	cd ieee1394;make

clean:
	cd lib;make clean
	cd hotplug;make clean
	#cd scripts;make clean
	cd config;make clean
	cd usb;make clean
	cd pci;make clean
	cd net;make clean
	cd ieee1394;make clean

clobber:
	cd lib;make clobber
	cd hotplug;make clobber
	cd usb;make clobber
	cd pci;make clobber
	cd net;make clobber
	cd ieee1394;make clobber

install:
	cd config;make install
	#cd scripts;make install
	cd hotplug;make install
	cd usb;make install
	cd pci;make install
	cd net;make install
	cd ieee1394;make install

=== debian/changelog ===
murasaki (0.6.11-1) unstable; urgency=low

  * September 2003 release.
  * New maintainer stable release :
    - add: murasaki_init.pci launch a hotplug only for Cardbus devices
  * Add INIT Variable to init script(true by default). Initialize only 
    if INIT=on.
  * Bump Standards Version.

 -- Pierre Machard <pmachard@debian.org>  Fri, 26 Sep 2003 16:08:45 +0200

murasaki (0.6.10-1) unstable; urgency=low

  * Adpot (closes: #201384)
  * New upstream release
    - fix the problem of upgrade (closes: #193159, #197594)
  * Add manpages
  * Move to debhelper V4
  * Upgrade Standard Version do 3.6.0

 -- Pierre Machard <pmachard@debian.org>  Sun,  3 Aug 2003 17:57:23 +0200

murasaki (0.6.6-1) unstable; urgency=low

  * New upstream release

 -- Yoshiaki Yanagihara <yochi@debian.org>  Wed, 30 Apr 2003 11:59:18 +0900

murasaki (0.6.4-1) unstable; urgency=low

  * New upstream release (Closes: #188023)
    - Fixed: Murasaki "hangs" on install/upgrade (Closes: #165680)
  * I forgot to close the bugs fixed by NMU (Closes: #150615, #160260)

 -- Yoshiaki Yanagihara <yochi@debian.org>  Tue,  8 Apr 2003 18:17:49 +0900

murasaki (0.6.1-5) unstable; urgency=low

  * Update configuration files: murasaki.usbmap, murasaki.depend. 

 -- Yoshiaki Yanagihara <yochi@debian.org>  Tue,  8 Oct 2002 23:08:20 +0900

murasaki (0.6.1-4) unstable; urgency=low

  * Maintainer Release
  * Added to check if the active kernel support usbdevfs.
  * Added initialize function to rc flie.
  * Clean up debian/rules file and dh_make templates files. (Closes: #160716)

 -- Yoshiaki Yanagihara <yochi@debian.org>  Fri,  4 Oct 2002 14:22:29 +0900

murasaki (0.6.1-3.1) unstable; urgency=low

  * NMU
  * Init script now exists silently if hotplug isn't supported by the
    kernel (closes: #150615)

 -- Tollef Fog Heen <tfheen@debian.org>  Fri, 13 Sep 2002 03:11:12 +0200

murasaki (0.6.1-3) unstable; urgency=low

  * Added to check if /proc/bus/usb has mounted already. (Closes: #146624)
  * NMU's Bug fix, I forgot to close. (Closes: #134209)

 -- Yoshiaki Yanagihara <yochi@debian.org>  Tue, 14 May 2002 11:06:01 +0900

murasaki (0.6.1-2) unstable; urgency=low

  * Modified the path of auto_setup script in init.d file.
  * Added the command to mount the usbdevfs to /proc/bus/usb.

 -- Yoshiaki Yanagihara <yochi@debian.org>  Wed,  8 May 2002 17:36:09 +0900

murasaki (0.6.1-1) unstable; urgency=low

  * New upstream release

 -- Yoshiaki Yanagihara <yochi@debian.org>  Wed,  8 May 2002 11:29:09 +0900

murasaki (0.5.4-2) unstable; urgency=low

  * Maintainer Release. 
  * Added debian/conffiles.
  * Changed to delete /etc/murasaki when the package is purged.

 -- Yoshiaki Yanagihara <yochi@debian.org>  Tue, 19 Feb 2002 12:26:44 +0900

murasaki (0.5.4-1.1) unstable; urgency=low

  * NMU (bug squash party)
  * Added /var/lock/subsys to debian/dirs - closes: #134209

 -- Masayuki Hatta <mhatta@debian.org>  Sun, 17 Feb 2002 18:21:01 +0900

murasaki (0.5.4-1) unstable; urgency=low

  * New Upstream Release.
  * Customized auto-setup script for Debian. (Closes: #131163)
  * BugFixed. (Closes: #117568)

 -- Yoshiaki Yanagihara <yochi@debian.org>  Mon,  4 Feb 2002 11:52:26 +0900

murasaki (0.5.0-1) unstable; urgency=low

  * New upstream release
   - Support IEEE1394 devices.

 -- Yoshiaki Yanagihara <yochi@debian.org>  Wed, 14 Nov 2001 18:38:36 +0900

murasaki (0.4.0-4) unstable; urgency=low

  * Rebuilt with new dpkg because 0.4.0-3 was REJECTed. 
  * Add new USB device.
    - Visor USB cradle [Handspring]. (Closes: #104185)

 -- Yoshiaki Yanagihara <yochi@debian.org>  Thu, 12 Jul 2001 10:21:56 +0900

murasaki (0.4.0-3) unstable; urgency=low

  * Corrected description message in debian/control.(Closes: #102631) 

 -- Yoshiaki Yanagihara <yochi@debian.org>  Sat, 30 Jun 2001 23:58:24 +0900

murasaki (0.4.0-2) unstable; urgency=low

  * New Maintainer. 
  * First Public Release.
  * Rewrite init script.
  * new murasaki.usbmap file.
    - Microsoft IntelliMouse<AE> Optical (4 button wheel)
    -  DeskJet 930C [HP]

 -- Yoshiaki Yanagihara <yochi@debian.org>  Tue, 19 Jun 2001 00:27:03 +0900

murasaki (0.4.0-1) unstable; urgency=low

  * Initial Release.

 -- Yoshito Komatsu <yoshito.komatsu@nifty.com>  Mon, 18 Jun 2001 21:06:41 +0900

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: murasaki
Section: admin
Priority: extra
Maintainer: Pierre Machard <pmachard@debian.org> 
Build-Depends: debhelper (>= 4)
Standards-Version: 3.6.1

Package: murasaki
Architecture: any
Depends: ${shlibs:Depends}, modutils (>=2.4.1)
Conflicts: hotplug, usbmgr
Description: another HotPlug Agent
 Murasaki automatically loads and unloads modules for USB, Cardbus,
 network, etc using Linux 2.4's new "HotPlug" feature.
 .
 Now kernel supports USB, Cardbus, Network and IEEE1394.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=4

build: build-stamp
build-stamp:
	dh_testdir
	#use xterminal-emulator instead of xterm
	patch -p2 config/auto_setup debian/patch/auto_setup.diff
	#diff do not preserve dependances
	chmod a+x config/auto_setup
	# Add here commands to compile the package.
	$(MAKE)
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clobber

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/murasaki.
	$(MAKE) install DESTDIR=$(CURDIR)/debian/murasaki


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installinit -u"start 01 2 3 4 5 . stop 99 0 1 6 ."
	dh_installman
	dh_installchangelogs Changes
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## murasaki 0.8.11

=== Makefile ===
#
# Makefile for murasaki
#
#			Shuu Yamaguchi <shuu@dotaster.com>

all:
	@cd lib;make
	@cd hotplug;make
	@cd usb;make
	@cd pci;make
	@cd generic;make
	@cd ieee1394;make
	@cd input;make
	@cd pcmcia_socket;make

clean:
	@cd lib;make clean
	@cd hotplug;make clean
	@cd scripts;make clean
	@cd config;make clean
	@cd usb;make clean
	@cd pci;make clean
	@cd generic;make clean
	@cd ieee1394;make clean
	@cd input;make clean
	@cd pcmcia_socket;make clean

clobber:
	@cd lib;make clobber
	@cd hotplug;make clobber
	@cd usb;make clobber
	@cd pci;make clobber
	@cd generic;make clobber
	@cd ieee1394;make clobber
	@cd input;make clobber
	@cd pcmcia_socket;make clobber

install:
	@cd config;make install
	@cd scripts;make install
	@cd hotplug;make install
	@cd usb;make install
	@cd pci;make install
	@cd generic;make install
	@cd ieee1394;make install
	@cd input;make install
	@cd pcmcia_socket;make install

diff:
	@cd lib;make diff
	@cd config;make diff
	@cd scripts;make diff
	@cd hotplug;make diff
	@cd usb;make diff
	@cd pci;make diff
	@cd generic;make diff
	@cd ieee1394;make diff
	@cd input;make diff
	@cd pcmcia_socket;make diff

=== config/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotaster.com

include ../make.defs

diff:
	@echo 'do nothing'

clean:
	@cp /dev/null $(PRELOAD_FILE)

clobber: clean

install:
	@if [ ! -d $(INST_CONF_DIR) ];then \
		install -d $(INST_CONF_DIR); \
		echo "make directory $(INST_CONF_DIR)"; \
	fi
	@[ -n "$(CONF_FILE)" ] && \
	for f in $(CONF_FILE); \
	do \
		if [ -f $(INST_CONF_DIR)/$$f -a ! -f $(INST_CONF_DIR)/$$f.old ];then \
			mv $(INST_CONF_DIR)/$$f $(INST_CONF_DIR)/$$f.old;\
			echo "move $(INST_CONF_DIR)/$$f $(INST_CONF_DIR)/$$f.old"; \
		fi;\
		install -m $(READ_MODE) $$f $(INST_CONF_DIR);\
		echo "install $(INST_CONF_DIR)/$$f"; \
	done
	@[ -n "$(NOT_OVERWRITE_CONF_FILE)" ] && \
	for f in $(NOT_OVERWRITE_CONF_FILE); \
	do \
		if [ ! -s $$f ];then \
			continue; \
		fi; \
		if [ -f $(INST_CONF_DIR)/$$f ];then \
			echo "---------------------------------------------"; \
			echo "$(INST_CONF_DIR)/$$f is not overwrited"; \
			echo "---------------------------------------------"; \
		else \
			install -m $(READ_MODE) $$f $(INST_CONF_DIR);\
			echo "install $(INST_CONF_DIR)/$$f"; \
		fi;\
	done

=== generic/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotAster.com
#
include ../make.defs

NAME=generic
SRCS=op.c
SRCS_RCS=$(SRCS)

include ../make.agent_defs

BINARY=$(CMD)
DEFS=
MAPS=

include ../make.rules

=== hotplug/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotaster.com
#
include ../make.defs

SRCS=hotplug.c
SRCS_RCS=$(SRCS)
OBJS=$(SRCS:.c=.o)
CMD=$(HOTPLUG)
BINARY=$(CMD)

DEFS=-DHOTPLUG_NAME=\"$(HOTPLUG)\" \
	-DMU_BIN_DIR=\"$(BIN_DIR)\" \
	-DMU_SCRIPT_DIR=\"$(SCRIPT_DIR)\" \
	-DGENERICLIST_PATH=\"$(CONF_DIR)/$(GENERICLIST_FILE)\"

include ../make.rules

=== ieee1394/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotAster.com
#
include ../make.defs

NAME=ieee1394
SRCS=id.c match.c print.c op.c
INIT_SRCS=init.c
SRCS_RCS=$(SRCS) $(INIT_SRCS)

include ../make.agent_defs

BINARY=$(CMD) $(INIT_CMD)
DEFS=-DMU_IEEE1394MAP=\"$(MAP)\" \
	     -DMU_DEFAULT_IEEE1394MAP=\"$(DEFAULT_MAP)\" 

include ../make.rules

=== input/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotAster.com
#
include ../make.defs

NAME=input
SRCS=op.c print.c match.c product.c array.c push_bit.c
# INIT_SRCS=init.c
SRCS_RCS=$(SRCS) $(INIT_SRCS)

include ../make.agent_defs

#BINARY=$(CMD) $(INIT_CMD)
BINARY=$(CMD)
MAPS=""
DEFS=-DMU_INPUTMAP=\"$(MAP)\" \
	-DMU_DEFAULT_INPUTMAP=\"$(DEFAULT_MAP)\" 

include ../make.rules

=== lib/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotAster.com

include ../lib.defs
include ../make.defs

SRCS=depend.c beep.c list.c script.c path.c action.c loader.c sysfs.c value.c save_sysdir.c proc.c filelist.c main.c exec_sysfs.c mmap.c string.c debug.c coldplug.c init.c exec.c permission.c
SRCS_RCS=$(SRCS)
OBJS=$(SRCS:.c=.o)

$(MURASAKI_LIB): $(OBJS)
	@echo "------------> $@"
	@ar rc $@ $?

%.o:%.c
	@echo "Compiling $@"
	@$(CC) $(CFLAGS) -c $< -o $@

clean:
	rm -f *.o

clobber: clean
	rm -f $(MURASAKI_LIB)

install:
	@echo 'nothing to do'

diff:
	rcsdiff $(SRCS_RCS)

test: clobber
	make CFLAGS='$(TEST_CFLAGS)'
	cd Test;make;cd ..

=== pci/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotaster.com
#
include ../make.defs

NAME=pci
SRCS=class.c id.c print.c match.c op.c sysfs.c
INIT_SRCS=init.c
SRCS_RCS=$(SRCS) $(INIT_SRCS)

include ../make.agent_defs

BINARY=$(CMD) $(INIT_CMD)
DEFS=-DMU_PCIMAP=\"$(MAP)\" \
	-DMU_DEFAULT_PCIMAP=\"$(DEFAULT_MAP)\" \
	-DONLY_CARDBUS

include ../make.rules

=== pcmcia_socket/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotAster.com
#
check:
	@if [ ! -d /usr/include/pcmcia ];then \
		echo "========================================================"; \
		echo "touch murasaki.pcmcia_socket murasaki_init.pcmcia_socket"; \
		touch murasaki.pcmcia_socket murasaki_init.pcmcia_socket; \
		echo "========================================================"; \
		exit 0; \
	else \
		make all; \
	fi

include ../make.defs

NAME=pcmcia_socket
SRCS=socket.c card.c op.c print.c match.c
INIT_SRCS=init.c resource.c socket.c lock.c
SRCS_RCS=$(SRCS) $(INIT_SRCS)

include ../make.agent_defs

BINARY=$(CMD) $(INIT_CMD)
DEFS=-DMU_PCMCIAMAP=\"$(MAP)\"
MAPS += pcmcia_resource

include ../make.rules

=== scripts/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotAster.com
#
include ../make.defs

SCRIPT_EXEC=auto_setup block block_mount block_umount command.template \
	env firmware net pcmcia_socket_analyze pcmcia_socket_convert \
	printer set_user
SCRITP_CONFIG=block_config net_config printer_config
SCRIPT_FUNCTION=block_functions func_debug func_desktop func_label \
	func_lock func_log func_rc func_sysfs func_user \
	func_wait net_functions pci_functions usb_functions
SCRIPT_READ=$(SCRIPT_FUNCTION) $(SCRITP_CONFIG)
SRCS_RCS=rc.murasaki $(SCRIPT_EXEC) $(SCRIPT_FUNCTION)

install_rc:
	@sed -e "s@##HOTPLUG##@$(HOTPLUG)@" -e "s@##PRELOAD_FILE##@$(PRELOAD_FILE)@" $(RC_FILE) > $(RC_FILE).real
	@if [ -f $(INST_RC_INIT_DIR)/$(LM) -a ! -f $(INST_RC_INIT_DIR)/$(LM).old ];then \
		mv $(INST_RC_INIT_DIR)/$(LM) $(INST_RC_INIT_DIR)/$(LM).old;\
		echo "move $(INST_RC_INIT_DIR)/$(LM) $(INST_RC_INIT_DIR)/$(LM).old"; \
	fi
	@install -m $(BIN_MODE) $(RC_FILE).real $(INST_RC_INIT_DIR)/$(LM)
	@echo "install $(INST_RC_INIT_DIR)/$(LM)"
	@for level in ${RC_LEVEL_START}; \
	do \
		ln -sf ../init.d/$(LM) $(INST_RC_DIR)/rc$${level}.d/$(RC_LEVEL_STARTFILE); \
		echo "link $(INST_RC_INIT_DIR)/$(LM) -> $(INST_RC_DIR)/rc$${level}.d/$(RC_LEVEL_STARTFILE)" ;\
	done
	@for level in ${RC_LEVEL_KILL}; \
	do \
		ln -sf ../init.d/$(LM) $(INST_RC_DIR)/rc$${level}.d/$(RC_LEVEL_KILLFILE); \
		echo "link $(INST_RC_INIT_DIR)/$(LM) -> $(INST_RC_DIR)/rc$${level}.d/$(RC_LEVEL_KILLFILE)" ;\
	done

install_dir:
	@if [ ! -d $(INST_SCRIPT_DIR) ];then \
		mkdir -p $(INST_SCRIPT_DIR); \
	fi;
	@if [ ! -d $(INST_FIRMWARE_DIR) ];then \
		mkdir -p $(INST_FIRMWARE_DIR); \
	fi;

install_script_exec:
	@if [ -n "$(SCRIPT_EXEC)" ];then \
		install -m $(BIN_MODE) $(SCRIPT_EXEC) $(INST_SCRIPT_DIR);\
		echo "install $(SCRIPT_EXEC) ---> $(INST_SCRIPT_DIR)"; \
	fi

install_script_read:
	@if [ -n "$(SCRIPT_READ)" ];then \
		install -m $(READ_MODE) $(SCRIPT_READ) $(INST_SCRIPT_DIR);\
		echo "install $(SCRIPT_READ) ---> $(INST_SCRIPT_DIR)"; \
	fi

install: install_dir install_rc install_script_exec install_script_read

clean:
	rm -f $(RC_FILE).real

diff:
	rcsdiff $(SRCS_RCS)

=== usb/Makefile ===
#
# Makefile for murasaki
#                            shuu@dotAster.com
#
include ../make.defs

NAME=usb
SRCS=product.c type.c match.c print.c op.c sysfs.c
INIT_SRCS=init.c
SRCS_RCS=$(SRCS) $(INIT_SRCS)

include ../make.agent_defs

BINARY=$(CMD) $(INIT_CMD)
DEFS=-DMU_USBMAP=\"$(MAP)\" \
	-DMU_DEFAULT_USBMAP=\"$(DEFAULT_MAP)\" 

include ../make.rules

## murasaki 1.68.6

=== Makefile ===
# Handy Makefile
# Kris Popendorf 2005/10/14
# Murasaki project

#one Makefile to rule them all...

all: 
	$(MAKE) -C src all

#one Makefile to bring them all...

clean:
	-rm -rf *.o *~ .*~ core
	$(MAKE) -C src clean

#and in the darkness...

depend:
	$(MAKE) -C src depend

#bind them

=== src/Makefile ===
## Murasaki project Makefile
# by Kris Popendorf 

###########################
# End-user configurable parts:
# There are a few options here that the end user might want to adjust
# if the defaults cause problems.
##

## if you have MPI but don't want to use it, uncomment this line:
#USE_MPI=NO
## if have the Crypto++ library but you don't want to use it (or if the autodetect is failing) comment out this line. Or make it YES if you want to force its use despite autodetect failing.
#WITH_LIBCRYPTOPP = NO

#If your libraries (boost/cryptopp) are in another directory, add them here:
INCLUDE   = -I./include -I/usr/local/include -I/opt/local/include
LIBPATH   = -L/usr/local/lib -L/usr/lib -L/opt/local/lib
LDLIBS    = -lboost_regex-mt -lboost_filesystem-mt -lboost_iostreams-mt -lboost_system
##some systems might use this boost naming scheme, but they're a minority at this point
#LDLIBS    = -lboost_regex -lboost_filesystem -lboost_iostreams 
CPPFLAGS += $(OPTIM) $(INCLUDE) -Wall $(MARCH)
LDFLAGS  += $(LIBPATH)

## if you're really strapped for memory, commenting this out may save you a little memory at the cost of losing the ability to handle >2Gbp sequences
LARGESEQ_SUPPORT ?= YES

#######
# End users can/should stop modifying here
#####

## if you're desperately trying to compile for windows, you'll want to uncomment this line and adjust the section below
#WITH_MINGW ?= YES
MINGW_HOME ?= /usr/i586-mingw32msvc
ifeq "$(WITH_MINGW)" "YES"
CPPFLAGS += -D_WIN32_WINNT=0x500 -DWINVER=0x500 # Windows2000 and later

INCLUDE   += -I$(MINGW_HOME)/include
LIBPATH   += -L$(MINGW_HOME)/lib -L$(MINGW_HOME)/GTK/lib # GTK/lib for zlib
LDLIBS += -lboost_system -lz -lbz2 -lm
endif


#autodetect MPI/cryptopp availability
USE_MPI ?= $(shell perl makeconf.pl HASMPI)
WITH_LIBCRYPTOPP ?= $(shell perl makeconf.pl HASCRYPTOPP $(CXX) $(CPPFLAGS) $(LDFLAGS))

## debug related options. end users shouldn't change
#GPROF ?= YES
#WITH_SHM_MMAP ?= YES
WITH_SHM_SYSV ?= YES

OPTIM += -O3
OPTIM += -DNDEBUG
OPTIM += -g

#sane defaults. when using MPI, the make default doesn't cut it.
ifeq "$(USE_MPI)" "YES"
DEFAULT_CXX = mpicxx
else
DEFAULT_CXX := $(CXX)
endif

ifeq "${origin CXX}" "default"
CXX = $(DEFAULT_CXX)
else
CXX ?= $(DEFAULT_CXX)
endif

#openhash specific options:
#CPPFLAGS += -DHASHPROFILE

MACOS_ARCH ?= ppc # ppc64

BINDIR = ..
DEPEND= gccmakedep
TMP = /tmp

#------------- Architecture stuff ---------

UNAME ?= ${shell uname -m}

ifeq "$(UNAME)" "i686"
#MARCH ?= -march=k8
endif
ifeq "$(UNAME)" "x86_64"
#MARCH ?= -march=opteron
endif
ifeq "$(UNAME)" "Darwin"
MARCH ?= -arch $(MACOS_ARCH)
endif
ifeq "$(UNAME)" "Power Macintosh"
MARCH ?= -arch $(MACOS_ARCH)
endif

#------------- Options --------------------

ifeq "$(GPROF)" "YES"
LDFLAGS	 += -pg
CPPFLAGS	 += -pg
CPPFLAGS += -pg
endif

ifeq "$(USE_MPI)" "YES"
CPPFLAGS   += -DMURASAKI_MPI
#CPPFLAGS   += -I/usr/lib/mpich/include -I/usr/local/mpich/include
#OPT_LIBS += -L/usr/lib/mpich/lib     -L/usr/local/mpich/lib -lmpich

#note: MPI requierd to use MMAP/SYSV (thus contained in MPI if)
ifeq "$(WITH_SHM_MMAP)" "YES"
CPPFLAGS += -DUSE_SHM_MMAP
endif

ifeq "$(WITH_SHM_SYSV)" "YES"
CPPFLAGS += -DUSE_SHM_SYSV
endif

endif

ifeq "$(LARGESEQ_SUPPORT)" "YES"
CPPFLAGS += -DLARGESEQ_SUPPORT
endif

ifeq "$(WITH_LIBCRYPTOPP)" "YES"
LDLIBS += -lcryptopp -pthread
#the way we use libcrypto actually breaks strict-aliasing rules (we convert bytes to words directly), so, just turn that off
CPPFLAGS += -DUSE_LIBCRYPTOPP -fno-strict-aliasing
endif

#------------- SVN Version info -----------

SVNREVISION=$(shell perl svninfo.pl)
ifneq "$(SVNREVISION)" ""
CPPFLAGS += -DSVNREVISION='$(SVNREVISION)'
endif

#------------- HG Version info -----------

HGREVISION=$(shell perl hginfo.pl)
ifneq "$(HGREVISION)" ""
CPPFLAGS += -DHGREVISION='$(HGREVISION)'
endif

#------------- Project files --------------

PROGRAM = $(BINDIR)/murasaki

SRCS = align-and.cc align-best.cc align-compare.cc align-coverage.cc align-mask.cc alignments.cc align-or.cc align-tc.cc arrayhash.cc cgr.cc cgr-compare.cc cgr-image.cc cgr-random.cc cgr-sample.cc dinkymath.cc ecohash.cc ecolist.cc geneparse.cc genopts.cc getsegments.cc msethash.cc murasaki.cc murasaki_mpi.cc openhash.cc options.cc scoring.cc seqread.cc sequence.cc timing.cc binseq.cc

OBJ = murasaki.o timing.o dinkymath.o sequence.o msethash.o options.o ecohash.o ecolist.o murasaki_mpi.o arrayhash.o seqread.o scoring.o openhash.o genopts.o binseq.o

ifeq "$(WITH_MINGW)" "YES"
SRCS += mingw32compat.cc
OBJ += mingw32compat.o
endif

PROG2 = $(BINDIR)/cgr-image
PROG3 = $(BINDIR)/cgr-compare
PROG4 = $(BINDIR)/cgr-random
PROG5 = $(BINDIR)/cgr-sample
PROG6 = $(BINDIR)/testeco
PROG7 = $(BINDIR)/align-compare
PROG8 = $(BINDIR)/align-or
PROG9 = $(BINDIR)/geneparse
PROG10 = $(BINDIR)/align-and
PROG11 = $(BINDIR)/align-best
PROG12 = $(BINDIR)/align-coverage
PROG13 = $(BINDIR)/getsegments
PROG16 = $(BINDIR)/mbfa


OBJ2 = cgr-image.o cgr.o dinkymath.o timing.o seqread.o  genopts.o
OBJ3 = cgr-compare.o cgr.o dinkymath.o timing.o
OBJ4 = cgr-random.o cgr.o dinkymath.o timing.o
OBJ5 = cgr.o cgr-sample.o seqread.o genopts.o
OBJ6 = testeco.o ecolist.o dinkymath.o timing.o
OBJ7 = align-compare.o dinkymath.o alignments.o timing.o
OBJ8 = align-or.o alignments.o dinkymath.o timing.o
OBJ9 = geneparse.o seqread.o genopts.o
OBJ10 = align-and.o alignments.o dinkymath.o timing.o
OBJ11 = align-best.o alignments.o dinkymath.o timing.o
OBJ12 = align-coverage.o alignments.o dinkymath.o timing.o seqread.o genopts.o
OBJ13 = getsegments.o seqread.o genopts.o
OBJ16 = mbfa.o dinkymath.o timing.o seqread.o binseq.o genopts.o

ALLPROGS = $(PROGRAM) $(PROG2) $(PROG3) $(PROG4) $(PROG5) $(PROG6) $(PROG7) $(PROG8) $(PROG9) $(PROG10) $(PROG11) $(PROG12) $(PROG13) $(PROG16)

#------------- Make rules -----------------

.cc.o:
	$(CXX) $(CPPFLAGS) -c $<

.cpp.o:
	$(CXX) $(CPPFLAGS) -c $<

#------------- Commands -------------------

all: $(ALLPROGS) Makefile

clean:
	-rm -rf *.o *~ .*~ core $(ALLPROGS)

depend: $(SRCS) Makefile
	$(DEPEND)  -- $(CPPFLAGS) -- $(SRCS) 2> $(TMP)/depend-errors

$(PROGRAM): $(OBJ)
	$(CXX) $(CPPFLAGS) -o $(PROGRAM) $(OBJ) $(OPT_LIBS) $(LIBPATH) $(LDLIBS)

$(PROG2): $(OBJ2)
	$(CXX) $(CPPFLAGS) -o $(PROG2) $(OBJ2) $(LIBPATH) $(LIBCGR) $(LDLIBS)

$(PROG3): $(OBJ3)
	$(CXX) $(CPPFLAGS) -o $(PROG3) $(OBJ3) $(LIBPATH) $(LIBCGR) $(LDLIBS)

$(PROG4): $(OBJ4)
	$(CXX) $(CPPFLAGS) -o $(PROG4) $(OBJ4) $(LIBPATH) $(LIBCGR) $(LDLIBS)

$(PROG5): $(OBJ5)
	$(CXX) $(CPPFLAGS) -o $(PROG5) $(OBJ5) $(LIBPATH) $(LIBCGR) $(LDLIBS)

$(PROG6): $(OBJ6)
	$(CXX) $(CPPFLAGS) -o $(PROG6) $(OBJ6) $(LIBPATH) $(LDLIBS)

$(PROG7): $(OBJ7)
	$(CXX) $(CPPFLAGS) -o $(PROG7) $(OBJ7) $(LIBPATH) $(LDLIBS)

$(PROG8): $(OBJ8)
	$(CXX) $(CPPFLAGS) -o $(PROG8) $(OBJ8) $(LIBPATH) $(LDLIBS)

$(PROG9): $(OBJ9)
	$(CXX) $(CPPFLAGS) -o $(PROG9) $(OBJ9) $(LIBPATH) $(LDLIBS)

$(PROG10): $(OBJ10)
	$(CXX) $(CPPFLAGS) -o $(PROG10) $(OBJ10) $(LIBPATH) $(LDLIBS)

$(PROG11): $(OBJ11)
	$(CXX) $(CPPFLAGS) -o $(PROG11) $(OBJ11) $(LIBPATH) $(LDLIBS)

$(PROG12): $(OBJ12)
	$(CXX) $(CPPFLAGS) -o $(PROG12) $(OBJ12) $(LIBPATH) $(LDLIBS)

$(PROG13): $(OBJ13)
	$(CXX) $(CPPFLAGS) -o $(PROG13) $(OBJ13) $(LIBPATH) $(LDLIBS)

$(PROG16): $(OBJ16)
	$(CXX) $(CPPFLAGS) -o $(PROG16) $(OBJ16) $(LIBPATH) $(LDLIBS)

codesize:
	wc $(SRCS)

##magical makedepend dependencies

=== debian/changelog ===
murasaki (1.68.6-6build5) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:20:48 +0000

murasaki (1.68.6-6build4) zesty; urgency=medium

  * Rebuild against new gdal 2.1.2+dfsg-1build1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 09 Nov 2016 08:33:37 +0100

murasaki (1.68.6-6build3) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:32:48 +0000

murasaki (1.68.6-6build2) zesty; urgency=medium

  * No-change rebuild against libopenmpi2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 22 Oct 2016 01:39:57 +0000

murasaki (1.68.6-6build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:26:27 +0000

murasaki (1.68.6-6) unstable; urgency=medium

  [ Gert Wollny ]
  * Team upload
  * d/p/gcc-6: Add patch to compile with gcc-6: Closes: #811815
  * cme fix dpkg-control 

  [ Andreas Tille ]
  * hardening=+bindnow

 -- Gert Wollny <gw.fossdev@gmail.com>  Thu, 30 Jun 2016 09:15:01 +0000

murasaki (1.68.6-5) unstable; urgency=medium

  * Upstream-Contact does not work any more
  * Moved packaging from SVN to Git
  * Turn README.Debian into README.test

 -- Andreas Tille <tille@debian.org>  Tue, 15 Mar 2016 18:07:31 +0100

murasaki (1.68.6-4) unstable; urgency=medium

  * Make sure arch independent packages can be built separately
    Closes: #806083

 -- Andreas Tille <tille@debian.org>  Tue, 24 Nov 2015 20:25:15 +0100

murasaki (1.68.6-3) unstable; urgency=medium

  * Enable build on kfreebsd (Thanks for the patch to Aaron M. Ucko
    <ucko@debian.org>)
    Closes: #789971

 -- Andreas Tille <tille@debian.org>  Fri, 03 Jul 2015 18:50:47 +0200

murasaki (1.68.6-2) unstable; urgency=medium

  * Do not try to access dirs from arch all package when doing arch any
    only builds
    Closes: #789827, #789880
  * Small DEP5 format fix

 -- Andreas Tille <tille@debian.org>  Thu, 25 Jun 2015 08:56:17 +0200

murasaki (1.68.6-1) unstable; urgency=medium

  * Initial release (Closes: #782697)
  * Split up into murasaki and murasaki-mpi (+murasaki-common)

 -- Andreas Tille <tille@debian.org>  Thu, 16 Apr 2015 08:51:12 +0200

murasaki (1.68.6-0ubuntu1) trusty; urgency=medium

  * Test upload to Debian Med PPA

 -- Andreas Tille <tille@debian.org>  Wed, 15 Apr 2015 14:06:19 +0200

=== debian/control ===
Source: murasaki
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               libboost-regex-dev,
               libboost-iostreams-dev,
               libboost-filesystem-dev,
               libterm-readkey-perl,
               libtext-wrapper-perl,
               libcrypto++-dev,
               libpstreams-dev,
               libopenmpi-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/murasaki.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/murasaki.git
Homepage: http://murasaki.dna.bio.keio.ac.jp/wiki/

Package: murasaki
Architecture: any
Depends: murasaki-common,
         ${shlibs:Depends},
         ${misc:Depends}
Description: homology detection tool across multiple large genomes
 Murasaki is a scalable and fast, language theory-based homology
 detection tool across multiple large genomes. It enable whole-genome
 scale multiple genome global alignments. Supports unlimited length
 gapped-seed patterns and unique TF-IDF based filtering.
 .
 Murasaki is an anchor alignment software, which is
  * exteremely fast (17 CPU hours for whole Human x Mouse genome (with
    40 nodes: 52 wall minutes))
  * scalable (Arbitrarily parallelizable across multiple nodes using MPI.
    Even a single node with 16GB of ram can handle over 1Gbp of sequence.)
  * unlimited pattern length
  * repeat tolerant
  * intelligent noise reduction

Package: murasaki-mpi
Architecture: any
Depends: murasaki-common,
         ${shlibs:Depends},
         ${misc:Depends}
Description: homology detection tool across multiple large genomes (MPI-version)
 Murasaki is a scalable and fast, language theory-based homology
 detection tool across multiple large genomes. It enable whole-genome
 scale multiple genome global alignments. Supports unlimited length
 gapped-seed patterns and unique TF-IDF based filtering.
 .
 Murasaki is an anchor alignment software, which is
  * exteremely fast (17 CPU hours for whole Human x Mouse genome (with
    40 nodes: 52 wall minutes))
  * scalable (Arbitrarily parallelizable across multiple nodes using MPI.
    Even a single node with 16GB of ram can handle over 1Gbp of sequence.)
  * unlimited pattern length
  * repeat tolerant
  * intelligent noise reduction
 .
 This package provides the MPI-enabled binary for murasaki.  While this
 will speed up operation on multi-processor machines it will slow down
 on a single processor.

Package: murasaki-common
Architecture: all
Depends: ${misc:Depends},
         ${misc:perl},
         gnuplot | gnuplot5,
         libbio-perl-perl,
         r-cran-rocr,
         imagemagick
Recommends: libterm-readkey-perl,
            libtext-wrapi18n-perl | libtext-wrapper-perl
Description: homology detection tool across multiple large genomes (common files)
 Murasaki is a scalable and fast, language theory-based homology
 detection tool across multiple large genomes. It enable whole-genome
 scale multiple genome global alignments. Supports unlimited length
 gapped-seed patterns and unique TF-IDF based filtering.
 .
 Murasaki is an anchor alignment software, which is
  * exteremely fast (17 CPU hours for whole Human x Mouse genome (with
    40 nodes: 52 wall minutes))
  * scalable (Arbitrarily parallelizable across multiple nodes using MPI.
    Even a single node with 16GB of ram can handle over 1Gbp of sequence.)
  * unlimited pattern length
  * repeat tolerant
  * intelligent noise reduction
 .
 This package contains all files that are common to the single core murasaki
 package and the multi core murasaki-mpi package.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for murasaki
# Copyright 2015 Andreas Tille
# GPL

DEBPKGNAME	:= $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
DEBMEDBIN	:= debian/$(DEBPKGNAME)-common/usr/lib/debian-med/bin
MANDIR		:= debian/$(DEBPKGNAME)/usr/share/man/man1
CMANDIR		:= debian/$(DEBPKGNAME)-common/usr/share/man/man1
MMANDIR		:= debian/$(DEBPKGNAME)-mpi/usr/share/man/man1

# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# leads to linking failure:
# /usr/bin/ld: murasaki.o: relocation R_X86_64_32 against `.rodata.str1.1' can not be used when making a shared object; recompile with -fPIC
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- USE_MPI=YES
	for bin in geneparse mbfa murasaki cgr-* testeco align-* ; do \
	    mv $${bin} $${bin}-mpi ; \
	done
	make clean
	dh_auto_build -- USE_MPI=NO

override_dh_installman-indep:
	dh_installman -i
	# create manpages for PL files
	mkdir -p $(CMANDIR)
	for pscript in $(DEBMEDBIN)/* ; do \
	    pod2man $${pscript} > $(CMANDIR)/`basename $${pscript}`.1 ; \
	done
	find $(CMANDIR) -empty -delete

override_dh_link:
	dh_link
	mkdir -p $(MMANDIR)
	for man in $(MANDIR)/* ; do \
	    ln -s `basename $${man}`.gz $(MMANDIR)/`basename $${man} .1`-mpi.1.gz ; \
	done

override_dh_install-arch:
	dh_install -a
	# using wildcards in install files is practical but it duplicates some files
	find debian/$(DEBPKGNAME)/usr -name "*-mpi" -delete

override_dh_fixperms-indep:
	dh_fixperms -i
	chmod a+x debian/$(DEBPKGNAME)-common/usr/share/perl5/murasaki/config.pl

=== debian/watch ===
version=3
http://sf.net/murasaki/murasaki-src-(\d[\d\.]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
